#The intermediate form of disassembled instructions can now be
#manipulated by adding code to the "while ( $insn ) " loop. As an
#example, the following code creates cross references:

# insn_xref.pl -- generate xrefs for data from int_code.pl
	# NOTE: this changes the file format to
	# INSN|addr|name|size|bytes|mem|mtyp|src|styp|dest|dtype|arg|atyp|xrefs

	my %xrefs;	# add this global variable

	# new version of while (insn) loop
	$insn = $head;
	while ( $insn ) {
		 gen_xrefs( $insn, $$insn{src}, $$insn{stype} );
		 gen_xrefs( $insn, $$insn{dest}, $$insn{dtype} );
		 gen_xrefs( $insn, $$insn{arg}, $$insn{atype} );
		 $insn = $$insn{next};
	}

	# output loop
	$insn = $head;
	while ( $insn ) {
		if ( $xrefs{$$insn{addr}} ) {
			chop $xrefs{$$insn{addr}};	# remove trailing colon
		}
		print "INSN|";				# print line type
		print "$$insn{addr}|$$insn{name}|$$insn{size}|$$insn{bytes}|";
		print "$$insn{mnem}|$$insn{mtype}|$$insn{src}|$$insn{stype}|";
		print "$$insn{dest}|$$insn{dtype}|$$insn{arg}|$$insn{atype}|";
		print "$xrefs{$$insn{addr}}\n";
		$insn = $$insn{next};
	}

	sub gen_xrefs {
		local($i, $op, $op_type) = @_;
		local $addr;
		if ( $op_type eq "OP_ADDR" && $op =~ /0[xX]([0-9a-fA-F]+)/ ) {
			$addr = $1;
			$xrefs{$addr} .= "$$i{addr}:";
		}
		return;
	}
